functor
import
	Connection(offerUnlimited:Offer)
	Pickle(save)
	System(show:Show)
	Application(exit)
	Search(base)
define
	% Statikus unáris függvény létrehozása
	proc {MakeStat PO ?StatP}
		S P={NewPort S}
		N={NewName}
	in
		% Kliens oldal
		proc {StatP M}
			R in
			{Send P M#R}
			if R==N then skip else raise R end end
		end
		% Szerver oldal
		thread
			{ForAll S proc {$ M#R} thread try {PO M} R=N catch X then R=X end end end}
		end
	end
	% Statikus objektum létrehozása
	proc {NewStat Class Init Object}
   		Object={MakeStat {New Class Init}}
	end

	% E az L lista egyik eleme, Others a maradék elemek listája.
	proc {Choose L E Others}
		dis L=E|Others
		[]  X L1 O1 in L=X|L1 Others=X|O1 then {Choose L1 E O1}
		end
	end
	% E az E1 és E2 kifejezésekből 3 alapművelet egyikével képzett kifejezés
	proc {Expression E1 E2 E}
		dis	E='+'(E1 E2)
		[]	E='-'(E1 E2)
		[]	E='*'(E1 E2)
		end
	end
	% I az E kifejezés kiértékelésének eredménye
	proc {Eval E I}
		case E
		of '+'(E1 E2) then I={Eval E1}+{Eval E2}
		[] '-'(E1 E2) then I={Eval E1}-{Eval E2}
		[] '*'(E1 E2) then I={Eval E1}*{Eval E2}
		else I=E
		end
	end
	% Is számok listája, melyekből 3 alapművelettel felépíthető az Ex kifejezés, melynek eredménye I
	proc {Solve Is I Ex}
		choice	[Ex]=Is {Eval Ex I}
		[]		Ex1 Ex2 Ex3 Is1 Is2 in
				{Choose Is Ex1 Is1}
				{Choose Is1 Ex2 Is2}
				{Expression Ex1 Ex2 Ex3}
				{Solve Ex3|Is2 I Ex}
		end
	end

	% A számrejtvényeket megoldó osztály
	class Solver
		meth init
			skip
		end
		meth solve(Is I Exs)
			{Search.base.all proc {$ Root} {Solve Is I Root} end Exs}
		end
		meth exit
			{Application.exit 0}
		end
	end

	% A szerver és a jegy változója
	S T
in
	{NewStat Solver init S}
	{Offer S T}
	{Pickle.save T "ticket"}
	{Show T}
end